____________________________________________________________________________________________
____________________________________________________________________________________________

;                                   Screensaver
____________________________________________________________________________________________
____________________________________________________________________________________________
; This Demo is the result of several months of search for several programmers.
;
; Based on 'C' code by  Forger 'http://bcgrizzly.com/forger
; Information on Lucian Wizchik's site at classic.physiol.cam.ac.uk/scr
; First Asm version by Ron Thomas. http://www.rbthomas.freeserve.co.uk/
; Adds and improvements from Ron Thomas and Betov. http://betov.free.fr/SpAsm.html
;
; More text infos at Ron Page in the 'Screen Savers' directory.
;
; SpAsm: When compiling a new source, you get a File.exe. Rename it File.scr. After renaming
; and reloading, you can hit the [Run] Menu option, and SpAsm will add the 'S' parameter to
; the command Line, so that you can test your screen effect in saver mode. (If you [Run] a
; Saver with an Exe extension, you only fall in the 'Failure of Command Line analyse' case).
; Once the .scr extension is set, SpAsm does with it.
;
; Screen Savers CallBacks: The MainWindowProc for Screen savers have some specifics. Some
; Messages (we usually don't care) are *not* to be passed to DefWindowProc; we have to
; return FALSE for them. If you modify anything in the MainWindowProc, be prepared to long
; weeks of 'Reboot style' programation...
;
; Win Versions: Pay attention that, Screen Savers work different ways on the various
; platforms. The actual Message holdings, and other stuffs, seem to fit with any...
;
; Anyway, Screen Savers programing is the more painfull case you could imagine. Before
; implementing any new screen effect, fully test it as a simple "Effect.exe" PE. For
; implementation too, be prepared to long days of 'Reboot style' programation. For
; viewing any value, fill the 'Testvalue' to be outputed when leaving the Message loop.
; (Do not attempt any 'Hexprint' inside the runing Saver).
;
; One simple example of Screen Savers jokes: In the Config Dialog, i wanted a TrackBar
; to define the custom value. In SpAsm Dialog Editor, runing under Win2000, this Trackbar
; works perfectely. But when runing the Win2000 installer, the Dialog aborts. I have
; never been able to fix why and had to switch to a Scroll Bar... Whereas such a Dialog,
; With TrackBar, prefectely works under 95/98 installers... Good luck everybody.

; note from: Eric Asbell
; I also read Lucian Wizchik's documentation. I made screensavers in C and really wished
; I could make them faster. I found asm, then SpASm! I converted my C screensaver to SpAsm.
; You will also see this source is a mix of HLL macros and low-level. I used low level for
; cmps and calls. I like 'em.
; Things to change to reuse:

; 1: Bitmap ID 750
; 2: Main Icon
; 3: About Box
; 4: QuantaKey.Registry Key
; 5: name of the scr
; 6: Bitmap Dimensions
_________________________________________________________________________________________
_________________________________________________________________________________________

[IsPreview: B$ &FALSE                                      ; Flag for preview mode
 szAppName:      'QuantaBounce',0
 CPanel:         'Control Panel\Desktop',0
 SCRNSaveUsePwd: 'ScreenSaveUsePassword',0
 PasswordCPL:    'PASSWORD.CPL',0
 VerifySSavePwd: 'VerifyScreenSavePwd' 0]

[ScreenDim: ScreenDim.X: 0    ScreenDim.Y: 0]              ; Struture for screen size.
[Rect: @left: 0     @top: 0     @right: 0     @bottom: 0]  ; Same.

[CommandLine: 0    MainWindowHandle: 0    ParentWindowHandle: 0]

; Bounce Data 
[cxClient:       D$        ?  
cyClient:        D$        ?
cxCentre:        D$        ?
cyCentre:        D$        ?
cxTotal:         D$        ?
cyTotal:         D$        ?
cxMove:          D$        ?
cyMove:          D$        ?
cxRadius:        D$        ?
cyRadius:        D$        ?
xPixel:          D$        ?
yPixel:          D$        ?
xCentre:         D$        ?
yCentre:         D$        ?
hDCMem:          D$        ?]
[hBitmap:        D$       &FALSE]
[BounceVelocity:    D$     1]
; End Bounce Data
____________________________________________________________________________________________
____________________________________________________________________________________________
; We first parse the command line to identify the arguments and then execute the
; appropriate routine.
;
; Note that the entered commandline string will be of the form
; C:\...\pgmname.exe followed by any arguments such as /c /s /p or /a
; Where /c is for the config mode
; /s is for the saver mode
; /p or /l is for the preview mode
; /a is for the password config dialog
;
; Command Line example: "C:\Windows\System\MyScreenSaver.scr/P 1176
; or:                   "C:\Windows\System\MyScreenSaver.scr/S
____________________________________________________________________________________________
____________________________________________________________________________________________

[FullScreen: 0]

Main:

    call 'KERNEL32.GetModuleHandleA' 0 | mov D$hInstance eax
    call 'KERNEL32.GetCommandLineA' | mov D$CommandLine eax

  ; Go to the end of Command Line:
    mov edi eax, al 0, ecx 0FF | repne scasb | sub edi 2 | mov esi edi
    
    mov eax 0, ecx 0
    
L0:     On B$esi-1 < '0', jmp L1>    ; Search for the start of
        On B$esi-1 > '9', jmp L1>    ; possible Decimal number Handle.
            dec esi
            jmp L0<
        
L1: push esi                          ; esi > either '1' or 'P' in upper example.

L2:     lodsb
        On al > '9', jmp L9>          ; Compute possible Handle
        On al < '0', jmp L9>
            sub al '0'                ; convert Decimal to binary:
            lea ecx D$ecx+ecx*4       ;     ecx = ecx * 5
            lea ecx D$eax+ecx*2       ;     ecx = eax + old ecx * 10
        jmp L2<
        
L9: pop esi

    If ecx > 0
       ; MessageBox argh 'Parent window Handle found in Command Line'
        mov B$IsPreview &TRUE, D$ParentWindowHandle ecx
        sub esi 2                                       ; jmp from '1' to 'P' (example)
    End_If
    
    mov al B$esi | and al 00_1101_1111                  ; Ucase the Key Char parameter.
    
  ; mov al 'C'                                  ; Example, for forcing tests...
        ;HexPrint eax
    .If al = 'A'                                ; PassWord config dialog
       ; MessageBox Argh 'A in CommandLine'
         call ChangePassword
         call 'KERNEL32.ExitProcess' 0
    .Else_If al = 'C'                           ; Config mode
       ; MessageBox Argh 'C in CommandLine'
         call 'USER32.DialogBoxParamA' D$hInstance 1000 D$ParentWindowHandle ConfigDlgProc 0
         call 'KERNEL32.ExitProcess' 0
    .Else_If al = 'S'                           ; Stand alone (user Double click on icon)
       ; MessageBox Argh 'S in CommandLine'     ; Saver mode
         mov B$FullScreen &TRUE
    .Else_If al = 'P'                           ; Preview mode (this is Small Computer mode)
      ;  MessageBox Argh 'P in CommandLine'
         mov B$FullScreen &FALSE
    .Else_If al = 02
        ; I recieve this in XP when called from the context menu..umm why?
         call 'USER32.DialogBoxParamA' D$hInstance 1000 D$ParentWindowHandle ConfigDlgProc 0
         call 'KERNEL32.ExitProcess' 0
    .Else
         MessageBox Argh 'CommandLine analyse failure'        
         call 'KERNEL32.ExitProcess' 0
    .End_If

    call 'GDI32.GetStockObject' &BLACK_BRUSH    ; Black screen.
    mov D$hbrBackground eax
    
    call 'USER32.LoadCursorA' 0 &IDC_ARROW | mov D$hcursor eax
 
    call 'USER32.RegisterClassExA' WNDCLASSEX

    .If D$ParentWindowHandle = 0                ; If there is no parent, use full screen:
        call 'USER32.GetSystemMetrics' &SM_CXSCREEN
        mov D$ScreenDim.x eax
        call 'USER32.GetSystemMetrics' &SM_CYSCREEN
        mov D$ScreenDim.y eax
        mov D$RECT@left 0, D$RECT@top 0
        mov D$Style &WS_VISIBLE__&WS_POPUP__&WS_EX_TOPMOST
       
    .Else                                       ; If there, we have a parent to fit with:
        call 'USER32.GetWindowRect' D$ParentWindowHandle RECT
        mov eax D$RECT@right | sub eax D$RECT@left | mov D$ScreenDim.x eax
        mov eax D$RECT@bottom | sub eax D$RECT@top | mov D$ScreenDim.y eax
        mov D$Style &WS_VISIBLE__&WS_CHILD
    .ENDIF
    
  ; Set the Animation dimensions according with screen (the Lenght of Ribbons is set
  ; up after Registry read with WM_INIT Message):
         
  ; mov B$FullScreen &FALSE                     ; for developement tests.
  
    call 'USER32.CreateWindowExA' 0 szAppName szAppName D$Style,
                                  0 0, D$ScreenDim.x D$ScreenDim.y,
                                  D$ParentWindowHandle 0 D$hInstance 0
    mov D$MainWindowHandle eax

    call 'USER32.ShowWindow' D$MainWindowHandle &SW_SHOWNORMAL

    On B$FullScreen = &TRUE, call 'User32.ShowCursor' &FALSE
    

  
L0: call 'USER32.GetMessageA' FirstMessage 0 0 0
    
      ; On eax = &FALSE, jmp L9>>                           ; For Tests exit.
        On eax = &FALSE, call 'KERNEL32.ExitProcess' 0      ; normal exit.
    
        call 'User32.TranslateMessage'  FirstMessage
    
        call 'User32.DispatchMessageA' FirstMessage
        
        ;Begin Bounce
        call 'KERNEL32.Sleep' 1
        ;End Bounce Code

    jmp L0<
    
; Tests exit:
[TestValue: 0]
L9:     hexprint D$TestValue

        call 'KERNEL32.ExitProcess' 0
____________________________________________________________________________________________
____________________________________________________________________________________________

[FirstMessage: 0 #7]

[WNDCLASSEX:
 cbSize:     D$ len
 style:         0
 lpfnWndProc:   MainWindowProc
 cbclsExtra:    0
 cbWndExtra:    0
 hInstance:     0
 hIcon:         0
 hcursor:       0
 hbrBackground: &COLOR_BACKGROUND+1   ; = 2   (&BLACK_BRUSH = 4)
 lpszMenuName:  0
 lpszClassName: szAppName
 hIconSm:       0]
____________________________________________________________________________________________
____________________________________________________________________________________________
; Make sure the user knows the password (if Password set on):

Proc VerifyPassword:

    Local @usepassword, @usepasswordsize, @hKey, @hPasswordCPL

        mov D@usepasswordsize, &PWLEN | lea eax D@hkey

        call 'ADVAPI32.RegOpenKeyA' &HKEY_CURRENT_USER CPanel eax      ; returns @hKey
        On eax <> 0, ExitTrue

        ; Get value for usepassword from registry:
        lea eax D@usepassword | lea ebx D@usepasswordsize
        call 'ADVAPI32.RegQueryValueExA' D@hKey SCRNSaveUsePwd 0 0 eax ebx
        On eax <> 0, ExitTrue

        call 'ADVAPI32.RegCloseKey' D@hKey

        On D@usepassword = 0, ExitTrue
        
        ; We have to get verification:
        call 'KERNEL32.LoadLibraryA' PasswordCPL
        mov D@hPasswordCPL eax

        call 'KERNEL32.GetProcAddress' D@hPasswordCPL VerifySSavePwd
        On eax = 0, ExitTrue
        mov D$VerifyScreenSavePwd eax

        call D$VerifyScreenSavePwd D$MainWindowHandle
        push eax
            call 'KERNEL32.FreeLibrary' D@hPasswordCPL
        pop eax ; eax= TRUE if good Password or none
EndP
____________________________________________________________________________________________
; The ChangePassword routine could as well be:
;
; call 'MPR.PwdChangePasswordA' SCRSAVE ecx 0 0
;
; ... under 95 family. This DLL doesn't have this function under NT family. So, we do have
; to do it by hand in order to prevent the loader from checking this function in the
; Import PE section:

[MPRhandle: 0    MPRDLL: 'MPR.DLL',0    PwdChgPassword: 'PwdChangePasswordA' 0
 SCRSAVE:        'SCRSAVE',0]

; To hold addresses of the MPR.DLL functions:
[PwdChangePassword:D$ 0    VerifyScreenSavePwd: 0]

ChangePassword:
    call 'KERNEL32.LoadLibraryA' MPRDLL | mov D$MPRhandle eax  ; > DLL handle
    call 'KERNEL32.GetProcAddress' D$MPRhandle  PwdChgPassword ; > routine Ptr in DLL
    mov D$PwdChangePassword eax

  ; Bring up the change password dialog:
    call D$PwdChangePassword SCRSAVE D$ParentWindowHandle 0 0  
    call 'KERNEL32.FreeLibrary' D$MPRhandle
ret
____________________________________________________________________________________________
____________________________________________________________________________________________
; Not used here.

[ClicksNumber: 0    NotFirstOne: 0]

; There is no particular return value to stand for this CallBack. you can do want you want
; here. But, be aware that, on slow computers, with time consuming animations, the timer
; is able to eat all of the Messages flow. When this appends, the only way to stop the
; Saver is the power button. Test Timer code on slow computers. Include too some exchange
; instruction between this Callback and the MainWindowProc, in order to make it live.
; For example, you can send a WM_TIMER message from here to MainWindowHandle and do some
; controls, in MainWindowProc of the Timer behaviour. Example: increasing the D$Period
; value if the timer is faster than the animation, killing the Timer and re-runing it with
; the new value...

Proc TimerProc:
    Arguments @ID, @Message, @UserValue, @wParam, @lParam   
EndP
____________________________________________________________________________________________
____________________________________________________________________________________________

[UserActions: &WM_MOUSEMOVE    &WM_KEYUP    &WM_KEYDOWN    &WM_LBUTTONDOWN
              &WM_RBUTTONDOWN  &WM_MBUTTONDOWN]
 
[OnPassWord: 0]


Proc MainWindowProc:
    Arguments @hWnd, @uMsg, @wParam, @lParam
    Local @dww
    Structure @PAINTSTRUCT 64 , @hdc 0

        pushad
        
        On B$OnPassWord = &TRUE, jmp L8>>
        
        mov edi UserActions, eax D@uMsg, ecx 5, ebx &FALSE | repne scasd | jne L1>
            On B$OnPassWord = &FALSE, mov ebx &TRUE
            
L1:     ...If D@uMsg = &WM_Paint
              
              cmp B$IsPreview &FALSE
              jne L1>
                          
              ;--Begin Bounce Code--
              push D@PAINTSTRUCT
              push D@hWnd
              call 'USER32.BeginPaint'          
              mov D@hdc, eax
              
              push D@hdc
              push D@hWnd
              call Paint_Proc
              
              push D@PAINTSTRUCT
              push D@hWnd
              call 'USER32.EndPaint'              
              ;--End Bounce Code--
            
              call 'USER32.RedrawWindow' D$MainWindowHandle 0  0,
                                         &RDW_INVALIDATE+&RDW_INTERNALPAINT
L1:                                         
              inc D$ClicksNumber
          
      ...Else_If D@uMsg = &WM_CREATE
                               
              ; If you want a Timer, this is the room for. Do not use the Win default
              ; one (too bad). The one of WINMM is better because is sends its ticks
              ; to a user defined Proc (see up there), and lives in its own thread:
              
              ;  > call 'WINMM.timeSetEvent' D$Period 10 TimerProc 0 &TIME_PERIODIC
              ;  > mov D$TimerID eax
              
              ; I let in the TimerProc Base (RightClick on 'TimerProc'...)
              
                If B$IsPreview = &FALSE
              ; Full screen: get rid of cursor and disable Ctrl/Alt/Del & Alt/Tab; etc.
                    call 'USER32.SetCursor' 0           ; Establish the cursors shape
                    call 'USER32.ShowCursor' &FALSE
                    lea eax D@dww
                    call 'USER32.SystemParametersInfoA' &SPI_SCREENSAVERRUNNING &TRUE eax 0
                    
                    ;retrieve the bounce velocity
                    call ReadRegistry 
                                        
                    ;--Begin Bounce Code--
                    
                    ; This is the width and height of the bitmap
                    mov D$cxTotal 296
                    mov D$cyTotal 313
                    
                    ;move the velocity into the move dwords
                    push eax                  
                    mov eax D$BounceVelocity
                    mov D$cxMove eax
                    mov eax D$BounceVelocity
                    mov D$cyMove eax
                    pop eax

                   ; load the bitmap from the resource file                   
                   push 750
                   push D$hInstance
                   call 'USER32.LoadBitmapA'
                   mov D$hBitmap, eax
                   
                   ;--End Bounce Code--
                   
                Else
                    ;Do If preview create code here  
                                                   
                End_If
                popad | ExitTrue

        ...Else_If D@uMsg = &WM_SIZE
        
                  cmp B$IsPreview &FALSE
                  jne L1>
                  
                  ;--Begin Bounce Code--
                  
                  ; Set = cxClient/2             
                  mov        eax,D@lParam
                  and        eax,0FFFF 
                  mov        D$cxClient,eax
                  shr        eax,1
                  mov        D$xCentre,eax                
                  
                  ; Set = cyClient/2
                  mov        ebx,D@lParam
                  shr        ebx,16 
                  mov        D$cyClient,ebx
                  shr        ebx,1
                  mov        D$yCentre,ebx  
                  ;--End Bounce Code--
L1:
        ...Else_If D@uMsg = &WM_CLOSE
            .If B$IsPreview = &TRUE                 ; Its a preview so close without a fuss
                call 'USER32.DestroyWindow' D@hWnd
            .Else                                   ; Saver: Close if Password known (if any)
                mov B$OnPassWord &TRUE
                call VerifyPassword
                mov B$OnPassWord &FALSE
                On eax = &TRUE, call 'USER32.DestroyWindow' D@hWnd
            .End_If
 
        ...Else_If D@uMsg = &WM_DESTROY
                      
            If B$IsPreview = &FALSE
              ; Make sure to set things back when we leave the saver:
              ; >  call 'WINMM.timeKillEvent' D$TimerID
                call 'USER32.LoadCursorA' 0 &IDC_ARROW
                call 'USER32.SetCursor' eax
                lea eax D@dww
                call 'USER32.SystemParametersInfoA' &SPI_SCREENSAVERRUNNING &FALSE eax 0
                
                ;--Begin Bounce Code--
                
                ; Clean up GDI
                push D@hdc
                push D@hWnd               
                call 'USER32.ReleaseDC'
                
                push D$hDCMem
                call 'GDI32.DeleteDC'

                push D$hBitmap
                call 'GDI32.DeleteObject'
                
                ;--End Bounce Code--
                
            End_If

            call 'USER32.PostQuitMessage' 0

        ...Else_If D@uMsg = &WM_SYSCOMMAND
            IF D@wParam = &SC_CLOSE                      ; Assert ourselves as screensaver
               ; popad | ExitFalse                       ; (Don't react).
            Else_If D@wParam = &SC_SCREENSAVE
               ; popad | ExitFalse
            ENDIF

        ...Else_If D@uMsg = &WM_SETCURSOR
            On B$OnPassWord = &FALSE, call 'USER32.SetCursor' 0
             
        ...Else_If D@uMsg = &WM_TIMER

        ...Else_If ebx = &TRUE                             ; User action
            ; If its a preview we don't care what goes on     
            ..If B$IsPreview = &FALSE
                call 'USER32.SetCursor' 0 ; If there's no cursor it returns Null 
                .If eax > 0
            ; Chances are that this is a stray message, so don't close quite yet
                    ExitFalse
            ; With Timer and fast animations, increase this control value (1) to
            ; purge the Message flow:
                .Else_If D$ClicksNumber > 50 ;Mouse Sens
                    If B$NotFirstOne = &FALSE
                        mov B$NotFirstOne &TRUE
                    Else
                        move D$TestValue  D@uMsg
                        call 'USER32.PostMessageA' D@hWnd &WM_CLOSE 0 0
                    End_If
                .End_If
            
            ..Else
                jmp L8>>
 
            ..End_If
        
       ...Else_If D@wParam = &FALSE
              If_Either D@uMsg = &WM_ACTIVATE,   ; We must return 0 for these Messages
                     or D@uMsg = &WM_NCACTIVATE, ; instead of passing them to
                     or D@uMsg = &WM_ACTIVATEAPP ; DefWindowProcA (in ScreenSavers).
              Else
                  jmp L8>
              End_If 

        ...Else
L8:         popad
            call 'USER32.DefWindowProcA' D@hWnd D@uMsg D@wParam D@lParam
            Exit

        ...End_If

        popad | mov eax &FALSE
EndP
____________________________________________________________________________________________
____________________________________________________________________________________________
; Registry jobs:

[hRegKey: 0    Result: 0    Datatype: 0    DwordSize: 4]

[ScreenSaver: B$ 'Screen Saver' 0
 QuantaKey:      'Software\Quanta\Screensavers\dangerwill' 0
 Velocity:       'Velocity' 0]
  
ReadRegistry:
    call 'ADVAPI32.RegCreateKeyExA' &HKEY_CURRENT_USER QuantaKey 0, 
                      ScreenSaver 0 &KEY_READ__&KEY_WRITE__&KEY_QUERY_VALUE,
                                    0 hRegKey Result
    If eax = &REG_CREATED_NEW_KEY                               ; Set speed
        mov D$BounceVelocity 1
        call 'ADVAPI32.RegSetValueExA' D$hRegKey Velocity 0,
         &REG_DWORD BounceVelocity D$DwordSize
    Else                                                        ; Get speed
        call 'ADVAPI32.RegQueryValueExA' D$hRegKey Velocity 0,
         Datatype BounceVelocity DwordSize
    End_If
    
    call 'ADVAPI32.RegCloseKey' D$hRegKey
    
ret

UpdateRegistry:    
    call 'ADVAPI32.RegOpenKeyExA' &HKEY_CURRENT_USER QuantaKey 0 &KEY_READ+&KEY_WRITE+&KEY_QUERY_VALUE hRegKey    
    call 'ADVAPI32.RegSetValueExA' D$hRegKey Velocity 0,
         &REG_DWORD BounceVelocity D$DwordSize   
    call 'ADVAPI32.RegCloseKey' D$hRegKey    
ret
____________________________________________________________________________________________
____________________________________________________________________________________________
; The Configuration Dialog Procedure called by the installer (the 'C' argument):

[TrackBarHandle: 0 ]
[Buffer: B$ 0 #10]
[Format: B$ '%lu ' 0]

[Title: 'Danger Will Robinson', 0

 Message: 
"
   Danger Will Robinson
  
  
   Written with SpAsm, Open Source Assembler:
   
   http://betov.free.fr/SpAsm.html
        (Source inside PE)
     ", 0]
     
; TrackBars do not work under Win2000 (not this way...); i replace with a Scroll Bar.

Proc ConfigDlgProc:
    Arguments @hWnd, @uMsg, @wParam, @lParam

        ...IF D@uMsg = &WM_INITDIALOG
            
            ;Load the main icon
            call 'USER32.LoadIconA' D$hInstance 1
            
            ;Tell the dialog to set the new icon                       
            call 'USER32.SendMessageA' D@hWnd &WM_SETICON &NULL eax      
        
            call ReadRegistry
            call 'USER32.GetDlgItem' D@hWnd 2  ; TrackBar = ID 2 in resources.
            mov D$TrackBarHandle eax
            call 'USER32.SendMessageA' D$TrackBarHandle &SBM_SETRANGE 1 10
            mov eax D$BounceVelocity, edx 0, ecx 1 | div ecx
            call 'USER32.SendMessageA' D$TrackBarHandle &SBM_SETPOS eax &TRUE
            
            ; Format the DWORD to ascii - Replace this -                       
            push D$BounceVelocity
            push Format
            push Buffer
            call 'USER32.wsprintfA'
            
            ;Place it in the Edit Box ID 10
            push Buffer
            push 10
            push D@hWnd
            call 'User32.SetDlgItemTextA'
                       
            ExitTrue
        
       ...Else_If D@uMsg = &WM_VSCROLL
                      
            If W@wParam = &SB_LINEDOWN 
                ;If they hit the down arrow            
                sub D$BounceVelocity 1
                
            Else_If W@wParam = &SB_LINEUP
                ;If they hit the up arrow
                add D$BounceVelocity 1                
            End_If
            
            ; the cmps below limit the vel to 1-10 no lower\greater
            cmp D$BounceVelocity 1 | jge L1>
            mov D$BounceVelocity 1
L1:                       
            cmp D$BounceVelocity 10 | jle L1>
            mov D$BounceVelocity 10
                      
L1:         
            ; Set the scrollbar pos based on vel                                 
            push &TRUE
            push D$BounceVelocity
            push &SB_VERT
            push D@hWnd
            call 'USER32.SetScrollPos'
            
            ; Format the DWORD to ascii - Replace this -        
            push D$BounceVelocity
            push Format
            push Buffer
            call 'USER32.wsprintfA'
            
            ;Place it in the Edit Box ID 10
            push Buffer
            push 10
            push D@hWnd
            call 'User32.SetDlgItemTextA'
                                             
        ...ELSEIF D@uMsg = &WM_COMMAND
            ..If D@wParam = &IDOK
                call UpdateRegistry
                call 'USER32.EndDialog' D@hWnd &FALSE

            ..Else_If D@wParam = &IDCANCEL
                call 'USER32.EndDialog' D@hWnd &TRUE
            
            ..Else_If D@wParam = &IDHELP
                call 'USER32.MessageBoxA' D@hWnd Message Title &MB_OK__&MB_SYSTEMMODAL
            
            ..End_If

        ...End_If
        
        mov eax &FALSE
EndP
____________________________________________________________________________________________
____________________________________________________________________________________________

;                                   The Animation:
;                                   Bouncing Bitmap
____________________________________________________________________________________________
____________________________________________________________________________________________

Proc Paint_Proc:  
        Arguments @hWind, @hDC

           cmp D$hBitmap &NULL | jne L1>
           ret    
L1:              
          call 'GDI32.CreateCompatibleDC' D@hDC  | mov  D$hDCMem eax
          call 'GDI32.SelectObject' D$hDCMem D$hBitmap
            
          ; xCentre - cxTotal/2   
          mov  ecx D$cxTotal | shr  ecx 1 | mov  eax D$xCentre | sub  eax ecx                        
          
          ; yCentre - cyTotal/2  
          mov  ebx D$cyTotal | shr  ebx 1 | mov  ecx D$yCentre | sub  ecx ebx                        
                                  
         call 'GDI32.BitBlt' D@hDC eax ecx D$cxTotal D$cyTotal D$hDCMem 0 0 &SRCCOPY                  
         call 'USER32.ReleaseDC' D@hWind D@hDC         
         call 'GDI32.DeleteDC' D$hDCMem
         
         ; xCentre = xCentre + cxMove 
         mov  eax D$xCentre | add  eax D$cxMove | mov  D$xCentre eax                        
         
         ; yCentre = yCentre + cyMove              
         mov  eax D$yCentre | add  eax D$cyMove | mov  D$yCentre ,eax                        

         mov  eax D$xCentre | add  eax D$cxRadius 
         mov  ecx D$xCentre | sub  ecx D$cxRadius

;        If the bitmap reaches either a vertical or horzontal boundary, reverse the horizontal or 
;        vertical direction and thereby simulate a "bounce" 
                      
            ;.IF  eax >= cxClient || ecx <= 0
            ; neg  cxMove                        
            ;.ENDIF
            
            ; Reverse x direction
            cmp eax D$cxClient | jge R1> | jmp L1>
L1:                  
            cmp ecx 0 | jle R1> | jmp L1>
                               
R1:         neg D$cxMove            
L1:
            mov eax D$yCentre | add eax D$cyRadius 
            mov ecx D$yCentre | sub ecx D$cyRadius
             
            ; .IF eax >= cyClient || ecx <= 0        
            ;  neg  cyMove                        
            ; .ENDIF
            
            ; Reverse y direction
            cmp eax D$cyClient | jge R2> | jmp L2>
L2:              
            cmp ecx 0 | jle R2> | jmp L2>           
R2:         neg D$cyMove      
L2:                                                
EndP
____________________________________________________________________________________________
; Test / debug routines:

[HexprintString: B$ '        h' 0   Hiho: 'HihoHiho' 0]

Proc HexPrnt:
    Argument @N
    
    pushad
        mov ebx D@N, ecx 8, edi HexPrintString | add edi 7
        std
            Do
                mov al bl | and al 0F | add al '0'
                On al > '9', add al 7
                stosb | shr ebx 4
            Do_Loop
        cld
        call 'USER32.MessageBoxA' &NULL HexPrintString Hiho &MB_OK ; &MB_SYSTEMMODAL__&MB_OK
    popad
EndP

Proc ShowYou:
    Argument @Pointer
    
    pushad
        call 'USER32.MessageBoxA' &NULL D@Pointer Hiho &MB_SYSTEMMODAL__&MB_OK
    popad
EndP

[Showme | push eax | lea eax D$#1 | call ShowYou eax | pop eax]
[Hexprint | call Hexprnt #1]

________________________________________________________________________________________

[Argh: 'Aaarrrghhh!!!!....', 0    Whaoo: 'Whaaaaoooo!!!!....', 0]

[MessageBox | {&0: #2 0} | call 'USER32.MessageBoxA' &NULL &0 #1 &MB_OK] ;&MB_SYSTEMMODAL__

____________________________________________________________________________________________
____________________________________________________________________________________________
; Macros:
;
; Macros reserved Local_Labels_Chars are: O I J K Z W X D E P
; O > On,    I/J/K/Z > If,    W/X > While,    D/E > Do,    P > Proc.

[push | push #1 | #+1]  [pop | pop #1 | #+1]

[mov | mov #1 #2 | #+2]
[inc | inc #1 | #+1]    [dec | dec #1 | #+1]

[On | cmp #1 #3 | jn#2 o1> | #4>L | o1:]

[call | push #L>2 | call #1]

[move | push #2 | pop #1 | #+2]

; If_Either eax = 1 or eax = 5 or eax =122

[If_Either    | cmp #1 #3 | j#2 I0> | #+4 | jmp I1> | I0:]
[.If_Either   | cmp #1 #3 | j#2 J0> | #+4 | jmp J1> | J0:]
[..If_Either  | cmp #1 #3 | j#2 K0> | #+4 | jmp K1> | K0:]
[...If_Either | cmp #1 #3 | j#2 Z0> | #+4 | jmp Z1> | Z0:]

; If_Are eax = 1 and eax = 5 and eax =122

[If_Are    | cmp #1 #3 | jn#2 I1> | #+4]
[.If_Are   | cmp #1 #3 | jn#2 J1> | #+4]
[..If_Are  | cmp #1 #3 | jn#2 J1> | #+4]
[...If_Are | cmp #1 #3 | jn#2 Z1> | #+4]

[If | cmp #1 #3 | jn#2 I1>]
[Else_if | jmp I9> | I1: | cmp #1 #3 | jn#2 I1>]
[Else | Jmp I9> | I1:]
[End_if | I1: | I9:]

[.If | cmp #1 #3 | jn#2 J1>>]
[.Else_if | jmp J9>> | J1: | cmp #1 #3 | jn#2 j1>>]
[.Else | Jmp j9>> | j1:]
[.End_if | j1: | j9:]

[..If | cmp #1 #3 | jn#2 K1>>]
[..Else_if | jmp K9>> | K1: | cmp #1 #3 | jn#2 K1>>]
[..Else | Jmp K9>> | K1:]
[..End_if | K1: | K9:]

[...If | cmp #1 #3 | jn#2 Z1>>]
[...Else_if | jmp Z9>> | Z1: | cmp #1 #3 | jn#2 Z1>>]
[...Else | Jmp Z9>> | Z1:]
[...End_if | Z1: | Z9:]

[While | W0: | cmp #1 #3 | jn#2 W9>]
[End_While | jmp W0< | W9:]

[.While | X0: | cmp #1 #3 | jn#2 X9>>]
[.End_While | jmp X0<< | X9:]

[Do | D0:]
[Loop_Until | cmp #1 #3 | jn#2 D0<]
[Do_Loop | Loop D0<]

[.Do | E0:]
[.Loop_Until | cmp #1 #3 | jn#2 E0<<]                   ; long
[.Do_Loop | Loop E0<]

[Exchange | push #1 | push #2 | pop #1 | pop #2]
_________________________________________________________________________________________
; Added Equates for more HLL-style in comparison Macros:

[= e   < b    > a    =< be    <= be    => ae    >= ae    <> ne]
_________________________________________________________________________________________
_________________________________________________________________________________________
; Proc Macros and Equates. Internal storages are:
;
; &1 <<< Size of Argument(s) (for ending Ret n, in EndP). Set by Argument(s)
; &2 <<< Size of Local (for Stack Management). Set by Local
; &3 <<< What to pop before ret. Set by Uses.

[Proc | &1=0 | &2=0 | &3= | #1 | push ebp | mov ebp esp]

[Exit | jmp P9>>]
[ExitTrue  | mov eax &TRUE  | jmp P9>>]
[ExitFalse | mov eax &FALSE | jmp P9>>]
                                                     
[Arguments | {#1 Arg#x} | #+1 | &1=SizeOf#x]
[Argument  | {#1 Arg#x} | #+1 | &1=SizeOf#x]
                                                     
[Local | {#1 Local#x} | #+1 | sub esp SizeOf#x | &2=SizeOf#x]
 
[StrucPtrs | {#3 ebp+#2+#F} | #+2]

[Structure | {#1 ebp-&2-4} | sub esp #2+4 | mov D$#1 esp | StrucPtrs 0-&2-#2-4 #L>3]

[Uses | push #1>L | &3=pop #L>1]

[EndP | P9: | &3 | mov esp ebp | pop ebp | ret &1]

; For pointing to transmitted parameters (upper "Arg#x" fall here):

[Arg1 ebp+8    Arg2 ebp+12    Arg3 ebp+16    Arg4 ebp+20   Arg5 ebp+24   
 Arg6 ebp+28   Arg7 ebp+32    Arg8 ebp+36    Arg9 ebp+40   Arg10 ebp+44]

; For pointing Local Stack declared data (upper "Local#x" fall here):

[Local1 ebp-4     Local2 ebp-8     Local3 ebp-12    Local4 ebp-16    Local5 ebp-20
 Local6 ebp-24    Local7 ebp-28    Local8 ebp-32    Local9 ebp-36    Local10 ebp-40]

; To help preventing from stack sizes' mistakes (upper "SizeOf#x" fall here):

[SizeOf1 4     SizeOf2 8     SizeOf3 12    SizeOf4 16    SizeOf5 20    
 SizeOf6 24    SizeOf7 28    SizeOf8 32    SizeOf9 36    SizeOf10 40]












